--- func_math.c.orig	2006-09-15 11:19:41.000000000 +0200
+++ func_math.c	2006-09-15 11:36:10.000000000 +0200
@@ -26,6 +26,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <sys/types.h>
+#include <math.h>
 
 #include "asterisk.h"
 
@@ -45,6 +46,9 @@
     MULTIPLYFUNCTION,
     SUBTRACTFUNCTION,
     MODULUSFUNCTION,
+    POWFUNCTION,
+    SHIFTLEFTFUNCTION,
+    SHIFTRIGHTFUNCTION,
 
     GTFUNCTION,
     LTFUNCTION,
@@ -109,6 +113,16 @@
 	} else if ((op = strchr(mvalue1, '%'))) {
 		iaction = MODULUSFUNCTION;
 		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'P'))) {
+		iaction = POWFUNCTION;
+		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'L'))) {
+		iaction = SHIFTLEFTFUNCTION;
+		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'R'))) {
+		iaction = SHIFTRIGHTFUNCTION;
+		*op = '\0';
+	
 	} else if ((op = strchr(mvalue1, '>'))) {
 		iaction = GTFUNCTION;
 		*op = '\0';
@@ -195,6 +209,27 @@
 		
 		break;
 	}
+	case POWFUNCTION :
+		ftmp = pow(fnum1,fnum2);
+		break;
+	case SHIFTLEFTFUNCTION :
+	{
+		int inum1 = fnum1;
+		int inum2 = fnum2;
+			
+		ftmp = (inum1 << inum2);
+		
+		break;
+	}
+	case SHIFTRIGHTFUNCTION :
+	{
+		int inum1 = fnum1;
+		int inum2 = fnum2;
+			
+		ftmp = (inum1 >> inum2);
+		
+		break;
+	}
 	case GTFUNCTION :
 		ast_copy_string (user_result, (fnum1 > fnum2)?"TRUE":"FALSE", sizeof (user_result));
 		break;
